; #########################################################################

  ; ---------------------------------------------------------------
  ;      This procedure was originally written by Tim Roberts 
  ;
  ; Part of this code has been optimised by Alexander Yackubtchik
  ; ---------------------------------------------------------------

CODE SECTION
; #########################################################################

dwtoa FRAME dwValue, lpBuffer
USES ebx,esi,edi
    ; -------------------------------------------------------------
    ; convert DWORD to ascii string
    ; dwValue is value to be converted
    ; lpBuffer is the address of the receiving buffer
    ; EXAMPLE:
    ; invoke dwtoa,edx,ADDR buffer
    ;
    ; Uses: eax, ecx, edx.
    ; -------------------------------------------------------------

    mov eax, [dwValue]
    mov edi, [lpBuffer]

    or eax,eax
    jnz >.sign
    
.zero
    mov W[edi],30h
    jmp >.dw2asc
    
.sign
    jns >.pos
    mov B[edi],'-'
    neg eax
    inc edi

.pos     

    mov ecx,429496730
    mov esi, edi

:
      mov ebx,eax
      mul ecx
      mov eax,edx
      lea edx,[edx*4+edx]
      add edx,edx
      sub ebx,edx
      add bl,'0'
      mov [edi],bl
      inc edi
    cmp eax,0
    jne <

    mov B[edi], 0       ; terminate the string

    ; We now have all the digits, but in reverse order.

    ;.while (esi < edi)
:
      dec edi
      mov al, [esi]
      mov ah, [edi]
      mov [edi], al
      mov [esi], ah
      inc esi
    cmp edi,esi
    jg <



.dw2asc
    
    ret

ENDF

; #########################################################################